// *********************************************************************
//  Created with bc9Basic - BASIC To C/C++ Translator (V) 9.1.6.9 (2013/10/30)
//       The bc9Basic translator (bc9.exe) was compiled with
//       Microsoft (R) C/C++ Optimizing Compiler Version 18.00.21005.1 for x86
// ----------------------------------------------------------------------
//                 BCX (c) 1999 - 2009 by Kevin Diggins
// *********************************************************************
//              Translated for compiling with a C++ Compiler
//                           On MS Windows
// *********************************************************************
#ifndef UNICODE
#define UNICODE
#endif
#ifndef _UNICODE
#define _UNICODE
#endif
// Additional lines may be needed
#if defined( __cplusplus )
  #include <iostream>
  #include <fstream>
  #include <sstream>
  #include <iomanip>
  #include <locale>
  #include <algorithm>
  #include <vector>
  typedef std::string::value_type charT;
  typedef std::string stdstr;
  using namespace std;
#endif
#include <windows.h>    // Win32 Header File 
#include <windowsx.h>   // Win32 Header File 
#include <commctrl.h>   // Win32 Header File 
#include <commdlg.h>    // Win32 Header File 
#include <mmsystem.h>   // Win32 Header File 
#include <shellapi.h>   // Win32 Header File 
#include <shlobj.h>     // Win32 Header File 
#include <objbase.h>    // Win32 Header File 
#include <ocidl.h>      // Win32 Header File 
#include <winuser.h>    // Win32 Header File 
#include <olectl.h>     // Win32 Header File 
#include <oaidl.h>      // Win32 Header File 
#include <ole2.h>       // Win32 Header File 
#include <oleauto.h>    // Win32 Header File 
#include <winsock.h>    // Win32 Header File 
#include <wchar.h>      // dos/linux 
#include <ctype.h>      // dos/linux
#include <fcntl.h>      // dos/linux
#include <math.h>       // dos/linux
#include <stdio.h>      // dos/linux
#include <string.h>     // dos/linux
#include <stdlib.h>     // dos/linux
#include <setjmp.h>     // dos/linux
#include <stdarg.h>     // dos/linux
#include <sys/types.h>  
#include <sys/stat.h>   
#include <tchar.h>
#include <wctype.h>
#define uni_gets(A) _fgetts(A,1024,stdin)


// ***************************************************
// Compiler Defines
// ***************************************************

// C++
#if defined( __cplusplus )
  #define overloaded
  #define C_EXPORT EXTERN_C __declspec(dllexport)
  #define C_IMPORT EXTERN_C __declspec(dllimport)
#else
  #define C_EXPORT __declspec(dllexport)
  #define C_IMPORT __declspec(dllimport)
#endif


// Microsoft VC++
#ifndef DECLSPEC_UUID
  #if (_MSC_VER >= 1100) && defined ( __cplusplus )
    #define DECLSPEC_UUID(x)    __declspec(uuid(x))
  #else
    #define DECLSPEC_UUID(x)
  #endif
#endif

// ***************************************************

#include <gl/GL.h>
#include <Uxtheme.h>
#include "GDImage.h"
#include "WinLIFT.h"
#include <SDKDDKVer.h>
//<---UNICODE AWARE
#pragma comment(linker,"\"/manifestdependency:type='win32' \
name='Microsoft.Windows.Common-Controls' version='6.0.0.0' \
processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")
//>---UNICODE AWARE
#define long_proc typedef long (__stdcall *zProc)


// *************************************************
// Instruct Linker to Search Object/Import Libraries
// *************************************************
#pragma comment(lib,"opengl32.lib")
#pragma comment(lib,"kernel32.lib")
#pragma comment(lib,"user32.lib")
#pragma comment(lib,"gdi32.lib")
#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"advapi32.lib")
#pragma comment(lib,"winspool.lib")
#pragma comment(lib,"shell32.lib")
#pragma comment(lib,"ole32.lib")
#pragma comment(lib,"oleaut32.lib")
#pragma comment(lib,"uuid.lib")
#pragma comment(lib,"odbc32.lib")
#pragma comment(lib,"odbccp32.lib")
#pragma comment(lib,"winmm.lib")
#pragma comment(lib,"comdlg32.lib")
#pragma comment(lib,"imagehlp.lib")
#pragma comment(lib,"version.lib")
// *************************************************
// End of Object/Import Libraries To Search
// *************************************************

// *************************************************
//        User's GLOBAL ENUM blocks
// *************************************************

// *************************************************
//            System Defined Constants
// *************************************************

typedef const _TCHAR* ccptr;
#define CCPTR const _TCHAR*
#define cfree free
#define WAITKEY _tsystem(_T("pause"))
#define cSizeOfDefaultString 2048 

// *************************************************
//            User Defined Constants
// *************************************************

#define _UBOUND(T)(T.size()) 
#define ZCHART_CLASS struct _ZCHART*
#define ClientW 1000 
#define ClientH 560 
#define ID_CTRL 101 
#define ID_RESET 102 
#define ID_LISTBOX 103 
#define ID_STATIC 112 
#define GL_MULTISAMPLE_ARB 0x809D 

// *************************************************
//               Standard Prototypes
// *************************************************

double  MIN (double,double);
double  MAX (double,double);
// *************************************************
//          User Defined Types And Unions
// *************************************************


typedef struct _ZCHART
{
  long     chartnumber;
  long     chartseries;
  float    radius;
  long     listindex;
}ZCHART, *LPZCHART;


// *************************************************
//            User Global Variables
// *************************************************

HWND    gn_GLwnd;
float   gr_Percent;
ZCHART  g_Chart;
long    gn_ChartCaption;
long    gn_ChartLegend;
long    gn_ChartSymbol;
long    gn_TexSpecular;
long    gn_TexChrome;
long    gn_TexBoing;
long    gn_TexBubble;
vector<ZGLTEXTUREX> g_mt;
vector<ZCHART_PARAM> g_Graph;
static int     ga;


// *************************************************
//               Standard Macros
// *************************************************


// *************************************************
//               User Prototypes
// *************************************************

wstring EXEpath (void);
wstring STRL (long);
HFONT   zDefaultFont (void);
void    zSetCTLFont (HWND,HFONT);
HWND    zStaticCenter (wstring,long,long,long,long,HWND,long);
void    GlobalFont (ZGLFONT &,long);
long    MinTrackSizeW (long);
long    MinTrackSizeH (long);
void    ListDeleteAll (HWND);
LRESULT ListAdd (HWND,WCHAR*);
void    ListSelectPlus (HWND,long);
LRESULT ListGetCursel (HWND);
wstring ListGetText (HWND,long);
void    gl_LoadTexture (HWND);
void    gl_InitGraph (void);
void    gl_ColorInit (void);
void    gl_Initialize (void);
void    gl_DestroyTexture (void);
void    gl_DisableAmbience (void);
void    gl_EnableAmbience (void);
void    gl_DrawScene (void);
LRESULT CALLBACK WndProc (HWND,UINT,WPARAM,LPARAM);
int     WINAPI _tWinMain (HINSTANCE,HINSTANCE,LPWSTR,int);

// *************************************************
//            User Global Initialized Arrays
// *************************************************

BYTE    g_R[34]={0};
BYTE    g_G[34]={0};
BYTE    g_B[34]={0};
BYTE    g_A[34]={0};


// *************************************************
//                 Runtime Functions
// *************************************************

double MAX (double a, double b)
{
  if(a>b)
  return a;
  return b;
}


double MIN (double a, double b)
{
  if(a<b)
  return a;
  return b;
}



// ************************************
//       User Subs and Functions
// ************************************

wstring EXEpath ()
{
  wstring  sResult={0};
  WCHAR    exepath[MAX_PATH]={0};
  if(GetModuleFileNameW(0,exepath,sizeof(exepath)))
    {
      sResult= exepath;
      sResult= sResult.substr( 0, sResult.rfind(_T("\\")));
      sResult+=_T("\\");
    }
  return sResult;
}


wstring STRL (long N)
{
  WCHAR    longstr[33]={0};
   _ltow_s(N,longstr,10);
  return (WCHAR*)longstr;
}


HFONT zDefaultFont ()
{
  static HFONT    hDefault;
  if(hDefault==0 )
    {
      hDefault=( HFONT) GetStockObject( ANSI_VAR_FONT);
    }
  return hDefault;
}


void zSetCTLFont (HWND hCtrl,HFONT  hFont)
{
  SendMessage(hCtrl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)FALSE);
}


HWND zStaticCenter (wstring  sLabel,long x,long y,long w,long h,HWND hParent,long nID)
{
  HWND     hCtl=CreateWindowEx(0,_T("STATIC"),sLabel.c_str(),WS_CHILD|WS_VISIBLE|WS_BORDER|SS_CENTER,x,y,w,h,hParent,(HMENU)nID,zInstance(),NULL);
  if(hCtl )
    {
      zSetCTLFont(hCtl,zDefaultFont());
    }
  return hCtl;
}


void GlobalFont (ZGLFONT   &UseFont,long RW)
{
  static ZGLFONT  WasFont;
  if(RW )
    {
      CopyMemory( &WasFont, &UseFont,sizeof(ZGLFONT));
    }
  CopyMemory( &UseFont, &WasFont,sizeof(ZGLFONT));
}


long MinTrackSizeW (long SizeX)
{
  static long     WasSizeX;
  if(SizeX )
    {
      WasSizeX= SizeX;
    }
  return WasSizeX;
}


long MinTrackSizeH (long SizeY)
{
  static long     WasSizeY;
  if(SizeY )
    {
      WasSizeY= SizeY;
    }
  return WasSizeY;
}


void ListDeleteAll (HWND hList)
{
  if(hList )
    {
      SendMessage(hList,(UINT)LB_RESETCONTENT,(WPARAM)0,(LPARAM)0);
    }
}


LRESULT ListAdd (HWND hList,WCHAR*  zTmp)
{
  LRESULT  nIndex={0};
  if(hList )
    {
      if(wcslen(zTmp))
        {
          nIndex= SendMessage( hList,( UINT) LB_ADDSTRING,( WPARAM) 0,( LPARAM) zTmp);
        }
    }
  return nIndex;
}


void ListSelectPlus (HWND hList,long nIndex)
{
  if(nIndex<0 )
    {
      hList= 0;
    }
  if(hList )
    {
      if(nIndex>0 )
        {
          --nIndex;
        }
      SendMessage(hList,(UINT)LB_SETCURSEL,(WPARAM)nIndex,(LPARAM)0);
    }
}


LRESULT ListGetCursel (HWND hList)
{
  LRESULT  nIndex={0};
  if(hList )
    {
      nIndex= SendMessage( hList,( UINT) LB_GETCURSEL,( WPARAM) 0,( LPARAM) 0);
      if(nIndex>-1 )
        {
          ++nIndex;
        }
    }
  return nIndex;
}


wstring ListGetText (HWND hList,long nItem)
{
  wstring  sData={0};
  if(nItem>0 )
    {
      --nItem;
      long     nLen=(long)SendMessage(hList,(UINT)LB_GETTEXTLEN,(WPARAM)nItem,(LPARAM)0)+1;
      WCHAR*   szData=new WCHAR[nLen];
      memset(szData,0,sizeof(WCHAR)*nLen);
      nLen=( long) SendMessage( hList,( UINT) LB_GETTEXT,( WPARAM) nItem,( LPARAM) szData);
      sData= szData;
      delete[] szData;
    }
  return sData;
}


void gl_LoadTexture (HWND hList)
{
  if(hList==0 )
    {
      return;
    }
  WIN32_FIND_DATAW  fd={0};
  WCHAR    zTmp[MAX_PATH]={0};
  WCHAR    zExt[8]={0};
  wstring  sExt={0};
  ListDeleteAll(hList);
  wstring  sImage=_T(".jpg.png.bmp.");
  wstring  sSearch=EXEpath();
  sSearch+=_T("Spec*.jpg");
  wcscpy_s(zTmp,(WCHAR*)sSearch.c_str());
  HANDLE   hFind=FindFirstFile(zTmp, &fd);
  long     nPos={0};
  long     nCount={0};
  if(hFind!=INVALID_HANDLE_VALUE )
    {
      int      IsOk=-1;
      while(IsOk)
        {
          if(!(fd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY))
            {
              sSearch= fd.cFileName;
              wcscpy_s(zTmp,(WCHAR*)sSearch.c_str());
              nPos=( long) sSearch.find_last_of(_T("."));
              sExt= sSearch.substr( nPos);
              sExt+=_T(".");
              wcscpy_s(zExt,(WCHAR*)sExt.c_str());
              CharLower(zExt);
              nPos=( long) sImage.find( zExt);
              if(nPos>-1 )
                {
                  if(ListAdd(hList,zTmp)>-1 )
                    {
                      nCount+=1;
                    }
                }
            }
          if(FindNextFile(hFind, &fd)==false)
            {
              IsOk= 0;
            }
        }

      FindClose(hFind);
    }
  if(nCount>0 )
    {
      ListSelectPlus(hList,1);
    }
}


void gl_InitGraph ()
{
  long     nChartSeries=7;
  long     nChartNumber=7;
  g_Chart.chartseries= MIN( nChartSeries, 13);
  g_Chart.chartnumber= MIN( nChartNumber, 13);
  g_Chart.radius= 1.0f;
  float    tabZ[13]={-24.0f,-26.0f,-28.0f,-30.0f,-34.0f,-38.0f,-42.0f,-47.0f,-50.0f,-53.0f,-57.0f,-60.0f,-62.0f};
  float    tabY[13]={-3.0f,-2.2f,-.5f,.6f,1.5f,2.5f,3.5f,4.0f,5.0f,6.5f,7.0f,8.3f,9.5f};
  long     nChartMax=MAX(g_Chart.chartseries,g_Chart.chartnumber);
  long     nChartMin=MIN(g_Chart.chartseries,g_Chart.chartnumber);
  float    rChartXoff=(-g_Chart.chartseries+g_Chart.chartnumber)*.8333f;
  float    rChartYoff=tabY[nChartMin-1];
  float    rChartZoff=tabZ[nChartMax-1];
  float    rChartZoom=1.0f;
  float    rChartXrot=45.0f;
  float    rChartYrot=-25.0f;
  GL_ChartSetMousing(rChartXoff,rChartYoff,rChartZoff,rChartZoom,rChartXrot,rChartYrot);
  gr_Percent= 0;
}


void gl_ColorInit ()
{
    g_R[33] = 32;  g_G[33] = 32;  g_B[33] = 32;  g_A[33] = 255;
    g_R[32] = 0;   g_G[32] = 44;  g_B[32] = 233; g_A[32] = 255;
    g_R[31] = 0;   g_G[31] = 67;  g_B[31] = 210; g_A[31] = 255;
    g_R[30] = 0;   g_G[30] = 89;  g_B[30] = 187; g_A[30] = 255;
    g_R[29] = 0;   g_G[29] = 112; g_B[29] = 164; g_A[29] = 255;
    g_R[28] = 0;   g_G[28] = 135; g_B[28] = 142; g_A[28] = 255;
    g_R[27] = 0;   g_G[27] = 159; g_B[27] = 117; g_A[27] = 255;
    g_R[26] = 0;   g_G[26] = 183; g_B[26] = 88;  g_A[26] = 255;
    g_R[25] = 0;   g_G[25] = 207; g_B[25] = 58;  g_A[25] = 255;
    g_R[24] = 0;   g_G[24] = 231; g_B[24] = 29;  g_A[24] = 255;
    g_R[23] = 26;  g_G[23] = 234; g_B[23] = 26;  g_A[23] = 255;
    g_R[22] = 52;  g_G[22] = 237; g_B[22] = 23;  g_A[22] = 255;
    g_R[21] = 79;  g_G[21] = 240; g_B[21] = 20;  g_A[21] = 255;
    g_R[20] = 105; g_G[20] = 243; g_B[20] = 17;  g_A[20] = 255;
    g_R[19] = 126; g_G[19] = 245; g_B[19] = 14;  g_A[19] = 255;
    g_R[18] = 147; g_G[18] = 248; g_B[18] = 11;  g_A[18] = 255;
    g_R[17] = 168; g_G[17] = 250; g_B[17] = 8;   g_A[17] = 255;
    g_R[16] = 189; g_G[16] = 253; g_B[16] = 5;   g_A[16] = 255;
    g_R[15] = 210; g_G[15] = 255; g_B[15] = 2;   g_A[15] = 255;
    g_R[14] = 233; g_G[14] = 255; g_B[14] = 0;   g_A[14] = 255;
    g_R[13] = 255; g_G[13] = 255; g_B[13] = 0;   g_A[13] = 255;
    g_R[12] = 255; g_G[12] = 251; g_B[12] = 0;   g_A[12] = 255;
    g_R[11] = 255; g_G[11] = 235; g_B[11] = 0;   g_A[11] = 255;
    g_R[10] = 255; g_G[10] = 215; g_B[10] = 0;   g_A[10] = 255;
    g_R[9]  = 255;  g_G[9] = 196;  g_B[9] = 0;    g_A[9] = 255;
    g_R[8]  = 255;  g_G[8] = 176;  g_B[8] = 0;    g_A[8] = 255;
    g_R[7]  = 255;  g_G[7] = 156;  g_B[7] = 0;    g_A[7] = 255;
    g_R[6]  = 253;  g_G[6] = 137;  g_B[6] = 0;    g_A[6] = 255;
    g_R[5]  = 255;  g_G[5] = 117;  g_B[5] = 0;    g_A[5] = 255;
    g_R[4]  = 255;  g_G[4] = 97;   g_B[4] = 0;    g_A[4] = 255;
    g_R[3]  = 255;  g_G[3] = 78;   g_B[3] = 0;    g_A[3] = 255;
    g_R[2]  = 255;  g_G[2] = 58;   g_B[2] = 0;    g_A[2] = 255;
    g_R[1]  = 255;  g_G[1] = 0;    g_B[1] = 0;    g_A[1] = 255;
}


void gl_Initialize ()
{
  srand((unsigned)time(NULL));
  glClearColor(.5f,.5f,.5f,1.0f);
  glClearDepth(1);
  glDepthFunc(GL_LESS);
  glEnable(GL_DEPTH_TEST);
  glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_FASTEST);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
  glEnable(GL_BLEND);
  glEnable(GL_LINE_SMOOTH);
  glShadeModel(GL_SMOOTH);
  float    LightDiffuse[4]={.4f,.4f,.4f,1.0f};
  float    LightAmbient[4]={.5f,.5f,.5f,1.0f};
  float    LightPosition[4]={-100.0f,-100.0f,400.0f,1.0f};
  glLightfv(GL_LIGHT0,GL_DIFFUSE, &LightDiffuse[0]);
  glLightfv(GL_LIGHT0,GL_AMBIENT, &LightAmbient[0]);
  glLightfv(GL_LIGHT0,GL_POSITION, &LightPosition[0]);
  glMaterialfv(GL_FRONT,GL_SPECULAR, &LightDiffuse[0]);
  float    rFloat=1.0f;
  glMaterialfv(GL_FRONT,GL_SHININESS, &rFloat);
  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING);
  glEnable(GL_COLOR_MATERIAL);
  glColorMaterial(GL_FRONT,GL_AMBIENT_AND_DIFFUSE);
  glEnable(GL_TEXTURE_2D);
  long     nK=0;
  long     nI=0;
  long     nJ=0;
  long     nC=0;
  long     nT=0;
  gl_InitGraph();
  g_Chart.listindex= 1;
  glGenLists(1);
  glNewList(g_Chart.listindex,GL_COMPILE);
  glColor4ub(255,255,255,64);
  GL_ChartAxis(g_Chart.chartseries*(g_Chart.radius*2.1f)+g_Chart.radius,10.0f,g_Chart.chartnumber*(g_Chart.radius*2.1f)+g_Chart.radius);
  glEndList();
  g_Graph.resize((g_Chart.chartnumber+1)*(g_Chart.chartseries+1));
  gl_ColorInit();
  for(nI=1;nI<=g_Chart.chartnumber;nI++)
    {
      nC=( nC+ 3) %  32+ 1;
      for(nJ=1;nJ<=g_Chart.chartseries;nJ++)
        {
          nK+=1;
          g_Graph[nK].nList= g_Chart.listindex+ nK;
          g_Graph[nK].nColor= nC;
          g_Graph[nK].rValue=( float)( rand() %  8+ 1);
          glNewList(g_Graph[nK].nList,GL_COMPILE);
          nT= nI;
          if(nT>CHART_MAX )
            {
              nT= nI %  CHART_MAX;
            }
               switch (nT) {
               case CHART_BAR:
                    g_Graph[nK].nType = nT;
                    g_Graph[nK].nTexture = gn_TexChrome;
                    g_Graph[nK].nTexSpec = TRUE;
                    GL_ChartBar(g_Chart.radius * 0.75f, g_Chart.radius * 0.75f, g_Graph[nK].rValue);
                    break;

               case CHART_CYLINDER:
                    g_Graph[nK].nType = nT;
                    g_Graph[nK].nTexture = gn_TexChrome;
                    g_Graph[nK].nTexSpec = TRUE;
                    GL_ChartCylinder(g_Chart.radius * 0.75f, g_Graph[nK].rValue, 32, 1);
                    break;

               case CHART_PYRAMIDE:
                    g_Graph[nK].nType = nT;
                    g_Graph[nK].nTexture = gn_TexChrome;
                    g_Graph[nK].nTexSpec = TRUE;
                    GL_ChartPyramide (g_Chart.radius * 0.75f, g_Graph[nK].rValue);
                    break;

               case CHART_SPHERE:
                    g_Graph[nK].nType = nT;
                    g_Graph[nK].nTexture = gn_TexBoing;
                    g_Graph[nK].nTexSpec = FALSE;
                    GL_ChartSphere(g_Chart.radius * 0.75f, g_Graph[nK].rValue, FALSE);
                    break;

               case CHART_CONE:
                    g_Graph[nK].nType = nT;
                    g_Graph[nK].nTexture = gn_TexChrome;
                    g_Graph[nK].nTexSpec = TRUE;
                    GL_ChartCone(g_Chart.radius * 0.75f, g_Graph[nK].rValue, 32, 1);
                    break;

               case CHART_POINT:
                    g_Graph[nK].nType = nT;
                    g_Graph[nK].nTexture = gn_TexBubble;
                    g_Graph[nK].nTexSpec = FALSE;
                    // ChartPoint is 2D surface, thus because of billboarding
                    // we couldn't compile it with the other 3D objects.
                    //GL_ChartPoint(g_Chart.radius * 0.75f, g_Graph[nK].rValue)
                    break;
               }
          glEndList();
        }

    }

}


void gl_DestroyTexture ()
{
  long     K={0};
  long     OkDelete={0};
  long     mtCount=(long)_UBOUND(g_mt);
  if(mtCount )
    {
      long*    Texture=new long[mtCount];
      memset(Texture,0,mtCount);
      for(K=0;K<mtCount;K++)
        {
          Texture[K]= g_mt[K].Texture;
          if(Texture[K])
            {
              OkDelete=- 1;
            }
        }

      if(OkDelete )
        {
          glDeleteTextures(mtCount,(GLuint*)Texture[0]);
        }
      delete []Texture;
    }
}


void gl_DisableAmbience ()
{
  glDisable(GL_LIGHT0);
  glDisable(GL_LIGHTING);
  glDisable(GL_COLOR_MATERIAL);
}


void gl_EnableAmbience ()
{
  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING);
  glEnable(GL_COLOR_MATERIAL);
}


void gl_DrawScene ()
{
  long     nK={0};
  long     nI={0};
  long     nJ={0};
  long     nC={0};
  float    rX={0.0};
  float    rY={0.0};
  float    rZ={0.0};
  float    rHalfRadius={0.0};
  float    rChartXoff={0.0};
  float    rChartYoff={0.0};
  float    rChartZoff={0.0};
  float    rChartZoom={0.0};
  float    rChartXrot={0.0};
  float    rChartYrot={0.0};
  WCHAR    zTitle[64]={0};
  wstring  ws;
  static long     nAngle;
  nAngle+=1;
  nAngle= nAngle %  360;
  if(gr_Percent<1 )
    {
      gr_Percent+=.002f;
    }
  static long     nFlip;
  nFlip=! nFlip;
  if(nFlip )
    {
      return;
    }
  if(GL_MultiSampleARB())
    {
      glEnable(GL_MULTISAMPLE_ARB);
    }
  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
  gl_DisableAmbience();
  glColor4ub(255,255,255,255);
  GL_BindTexture(GL_TEXTURE_2D,gn_TexSpecular);
  GL_DrawQuad(84.0f,42.0f,-99.99f);
  gl_EnableAmbience();
  GL_ChartGetMousing(rChartXoff,rChartYoff,rChartZoff,rChartZoom,rChartXrot,rChartYrot);
  glTranslatef(rChartXoff,rChartYoff,rChartZoff);
  glScalef(rChartZoom,rChartZoom,rChartZoom);
  glRotatef(-rChartYrot,1,0,0);
  glRotatef(-rChartXrot,0,1,0);
  ZGLFONT  UseFont={0};
  WCHAR    zTxt[16]={0};
  GlobalFont(UseFont,0);
  glPushMatrix();
  GL_BindTexture(GL_TEXTURE_2D,gn_TexChrome);
  rHalfRadius= g_Chart.radius*.5f;
  glTranslatef(g_Chart.radius+rHalfRadius ,.0f,g_Chart.radius+rHalfRadius);
  nK= 0;
  for(nI=1;nI<=g_Chart.chartnumber;nI++)
    {
      for(nJ=1;nJ<=g_Chart.chartseries;nJ++)
        {
          nK+=1;
          nC= g_Graph[nK].nColor;
          glColor4ub(g_R[nC],g_G[nC],g_B[nC],g_A[nC]);
          GL_BindTexture(GL_TEXTURE_2D,g_Graph[nK].nTexture);
          GL_TexSpec(g_Graph[nK].nTexSpec);
          if(gr_Percent<1 )
            {
     switch (g_Graph[nK].nType) {
     case CHART_BAR:
        GL_ChartBar(g_Chart.radius * 0.75f, g_Chart.radius * 0.75f, g_Graph[nK].rValue * gr_Percent);
        break;
     case CHART_CYLINDER:
        GL_ChartCylinder(g_Chart.radius * 0.75f, g_Graph[nK].rValue * gr_Percent, 32, 1);
        break;
     case CHART_PYRAMIDE:
        GL_ChartPyramide(g_Chart.radius * 0.75f, g_Graph[nK].rValue * gr_Percent);
        break;
     case CHART_SPHERE:
        GL_ChartSphere(g_Chart.radius * 0.75f, g_Graph[nK].rValue * gr_Percent, FALSE);
        break;
     case CHART_CONE:
        GL_ChartCone(g_Chart.radius * 0.75f, g_Graph[nK].rValue * gr_Percent, 32, 1);
        break;
     case CHART_POINT:
        GL_ChartPoint(g_Chart.radius * 0.75f, g_Graph[nK].rValue * gr_Percent);
        break;
     }

            }
          else
            {
              if(g_Graph[nK].nType==CHART_POINT )
                {
                  GL_ChartPoint(g_Chart.radius *.75f,g_Graph[nK].rValue);
                }
              else
                {
                  glCallList(g_Graph[nK].nList);
                }
            }
          GL_TexSpec(FALSE);
          glTranslatef(2.1f*g_Chart.radius ,.0f ,.0f);
        }

      glTranslatef((-2.1f*g_Chart.radius)*g_Chart.chartseries ,.0f,2.1f*g_Chart.radius);
    }

  glPopMatrix();
  GL_BindTexture(GL_TEXTURE_2D,gn_TexSpecular);
  for(nI=0;nI<11;nI++)
    {
      wcscpy_s(zTxt,(WCHAR*)STRL(nI*10 ).c_str());
      GL_DrawText(gn_GLwnd,UseFont,g_Chart.chartseries*(g_Chart.radius*2.1f)+g_Chart.radius -.1f,(float)nI,0,zTxt,ZD_ARGB(255,0,255,0));
      GL_DrawText(gn_GLwnd,UseFont ,.1f,(float)nI,g_Chart.chartnumber*(g_Chart.radius*2.1f)+g_Chart.radius +.5f,zTxt,ZD_ARGB(255,0,255,0));
    }

  glLineWidth(1.0f);
  glCallList(g_Chart.listindex);
  glPushMatrix();
  GL_TexSpec(TRUE);
  glColor4ub(255,255,255,128);
  rX= g_Chart.chartseries*( g_Chart.radius* 1.05f);
  rY= g_Chart.chartnumber*( g_Chart.radius* 1.05f);
  rZ= 0;
  glTranslatef(rX+g_Chart.radius *.5f,-.1f,rY+g_Chart.radius *.5f);
  GL_ChartBar(rX+g_Chart.radius*1.5f,rY+g_Chart.radius*1.5f,-.2f);
  GL_TexSpec(FALSE);
  glPopMatrix();
  GL_TexSpec(TRUE);
  rX= g_Chart.chartseries*( g_Chart.radius* 2.1f)+ g_Chart.radius;
  rY= 10;
  rZ= g_Chart.chartnumber*( g_Chart.radius* 2.1f)+ g_Chart.radius;
  glColor4ub(240,240,255,64);
  GL_ChartAxisPanel(rX,rY,rZ);
  GL_TexSpec(FALSE);
  glPushMatrix();;
  gl_DisableAmbience();;
  glColor4ub(255,255,255,255);
  for(nI=1;nI<=g_Chart.chartnumber;nI++)
    {
      glPushMatrix();
      glTranslatef((2.1f*g_Chart.radius)*g_Chart.chartseries+g_Chart.radius,rHalfRadius *.6f,g_Chart.radius+rHalfRadius*1.25f);
      GL_BillBoard();
      ws=( WCHAR) 128+( WCHAR) nI;
      GL_ChartSymbol(gn_GLwnd,gn_ChartSymbol,0,0,0,(WCHAR*)ws.c_str());
      glPopMatrix();
      glTranslatef(0,0,2.1f*g_Chart.radius);
    }

  gl_EnableAmbience();
  glPopMatrix();
  glPushMatrix();
  gl_DisableAmbience();
  glColor4ub(255,255,255,255);
  glTranslatef(g_Chart.radius+rHalfRadius *.5f ,.0f,2.1f*g_Chart.radius*g_Chart.chartnumber+rHalfRadius);
  for(nJ=1;nJ<=g_Chart.chartseries;nJ++)
    {
      ws=( WCHAR) 64+( WCHAR) nJ;
      GL_ChartLabel(gn_GLwnd,gn_ChartLegend,0,0,0,(WCHAR*)ws.c_str());
      glTranslatef(2.1f*g_Chart.radius ,.0f ,.0f);
    }

  glTranslatef((-2.1f*g_Chart.radius)*g_Chart.chartseries ,.0f,2.1f*g_Chart.radius);
  gl_EnableAmbience();
  glPopMatrix();
  glPushMatrix();
  glTranslatef(9.2f ,.0f,2.1f*g_Chart.radius*g_Chart.chartnumber+rHalfRadius*3.0f +.35f);
  glRotatef(-90,1,0,0);
  glColor4ub(255,255,0,255);
  ws=_T("GDImage ");
  ws+=ZI_Version();
  GL_ChartLabel(gn_GLwnd,gn_ChartCaption,0,0,0,(WCHAR*)ws.c_str());
  glPopMatrix();
  glPushMatrix();
  glLoadIdentity();
  gl_DisableAmbience();
  glDisable(GL_DEPTH_TEST);
  wcscpy_s(zTitle,_T("The title of the chart"));
  glTranslatef(GL_ChartGetTextLength(gn_ChartCaption,zTitle)*-.5f,-8.0f,-20.0f);
  glColor4ub(255,0,0,255);
  GL_ChartLabel(gn_GLwnd,gn_ChartCaption,0,0,0,zTitle);
  glEnable(GL_DEPTH_TEST);
  gl_EnableAmbience();
  glPopMatrix();
  ws=_T("Zoom ");
  ws+=STRL((long)(rChartZoom*100));
  ws+=_T(" %");
  ZI_DrawGLText(gn_GLwnd,UseFont,10,10+UseFont.fontHeight*0,(WCHAR*)ws.c_str(),ZD_ARGB(255,255,255,0));
  glFlush();
  if(GL_MultiSampleARB())
    {
      glDisable(GL_MULTISAMPLE_ARB);
    }
  ZI_UpdateGLWindow(gn_GLwnd);
}


LRESULT CALLBACK WndProc (HWND hWin,UINT uMsg,WPARAM  wParam,LPARAM  lParam)
{
  HWND     hCtrl;
  long     wmId;
  long     wmEvent;
  MINMAXINFO*  pMM;
  wstring  ws;
    switch (uMsg) {

    case WM_GETMINMAXINFO:
         pMM = (MINMAXINFO*) lParam;
         pMM->ptMinTrackSize.x = MinTrackSizeW(0);
         pMM->ptMinTrackSize.y = MinTrackSizeH(0);
         break;

    case WM_TIMER:
         gl_DrawScene();
         return 0;

    case WM_MOUSEWHEEL:
         if (GetFocus() != gn_GLwnd) { SetFocus(gn_GLwnd); }
         break;

    case WM_SIZE:
         ZI_ResizeGLWindow(gn_GLwnd);
         gl_DrawScene();
         break;

    case WM_COMMAND:
         wmId    = LOWORD(wParam);
         wmEvent = HIWORD(wParam);

         switch (wmId) {

         case ID_RESET:
              gl_InitGraph();
              ZI_ResizeGLWindow(gn_GLwnd);
              gl_DrawScene();
              break;

         case ID_LISTBOX:
              if (wmEvent == LBN_SELCHANGE) {
                  hCtrl = GetDlgItem(hWin, ID_LISTBOX);
                  ws = EXEpath(); ws += ListGetText(hCtrl, (long) ListGetCursel(hCtrl));
                  wcscpy_s(g_mt[0].FullName, (WCHAR*) ws.c_str());
                  ZI_UpdateNamedGLTextureFromFileEx(g_mt[0].FullName, g_mt[0].Texture, g_mt[0].Square);
              }
              break;
         }
         return 0;

    case WM_DESTROY:
         PostQuitMessage(0);
         return 0;
    }
    return DefWindowProc(hWin, uMsg, wParam, lParam);

}


int WINAPI _tWinMain (HINSTANCE  hInst,HINSTANCE  hPrev,LPWSTR  CmdLine,int CmdShow)
{
  UNREFERENCED_PARAMETER(hPrev);
  UNREFERENCED_PARAMETER(CmdLine);
  MSG      msg;
  long     nRet={0};
  WNDCLASSEX  wcx={0};
  WCHAR    szWindowClass[]=_T("ZCHART3D");
  RECT     rc;
  long     x;
  long     y;
  long     IsInitialized;
  DWORD    dwStyle;
  DWORD    dwExStyle;
  HWND     hMain;
  HWND     hList;
  HWND     hFound;
  ZGLFONT  UseFont={0};
  HANDLE   hMutex=CreateMutex(NULL,0,szWindowClass);
  if(hMutex )
    {
      if(GetLastError()==ERROR_ALREADY_EXISTS )
        {
          for(;;)
            {
              hFound= FindWindow( szWindowClass, NULL);
              if((hFound))
                {
                  break;
                }
              while((PeekMessage( &msg,NULL,NULL,NULL,PM_REMOVE)))
                {
                }

            }

          if(IsIconic(hFound))
            {
              ShowWindow(hFound,SW_RESTORE);
            }
          SetForegroundWindow(hFound);
          return 0;
        }
    }
  wcx.cbSize= sizeof( wcx);
  IsInitialized= GetClassInfoEx( hInst, szWindowClass,  &wcx);
  if(!IsInitialized )
    {
      wcx.style= CS_HREDRAW| CS_VREDRAW;
      wcx.lpfnWndProc= WndProc;
      wcx.cbClsExtra= 0;
      wcx.cbWndExtra= 0;
      wcx.hInstance= hInst;
      wcx.hIcon= LoadIcon( hInst, MAKEINTRESOURCE( IDI_APPLICATION));
      wcx.hCursor= LoadCursor( NULL, IDC_ARROW);
      wcx.hbrBackground=( HBRUSH)( COLOR_WINDOW+ 1);
      wcx.lpszMenuName= NULL;
      wcx.lpszClassName= szWindowClass;
      wcx.hIconSm= wcx.hIcon;
      if(RegisterClassEx( &wcx))
        {
          IsInitialized=- 1;
        }
    }
  if(IsInitialized )
    {
      dwExStyle= WS_EX_APPWINDOW| WS_EX_WINDOWEDGE;
      dwStyle= WS_OVERLAPPEDWINDOW| WS_CLIPSIBLINGS| WS_CLIPCHILDREN;
      SetRect( &rc,0,0,ClientW,ClientH);
      AdjustWindowRectEx( &rc,dwStyle,FALSE,dwExStyle);
      x= MAX(( GetSystemMetrics( SM_CXSCREEN)- rc.right- rc.left)/ 2, 0);
      y= MAX(( GetSystemMetrics( SM_CYSCREEN)- rc.bottom- rc.top)/ 2, 0);
      MinTrackSizeW(rc.right-rc.left);
      MinTrackSizeH(rc.bottom-rc.top);
      wstring  sCaption=_T("GDImage ");
      sCaption+=ZI_Version();
      if(sizeof(LONG_PTR)==8 )
        {
          sCaption+=_T(" 64-bit");
        }
      else
        {
          sCaption+=_T(" 32-bit");
        }
      sCaption+=_T(", 3D Chart demo");
      hMain= CreateWindowEx( dwExStyle, szWindowClass,( WCHAR*) sCaption.c_str(), dwStyle, x, y, MinTrackSizeW( 0), MinTrackSizeH( 0), NULL,(HMENU) NULL, hInst, NULL);
      if(hMain )
        {
          CreateWindowEx(0,_T("BUTTON"),_T("Reset"),WS_CHILD|WS_VISIBLE|WS_TABSTOP,ClientW-(7+120+8),10+(22+5)*2-2,120,30,hMain,(HMENU)ID_RESET,hInst,NULL);
          zSetCTLFont(GetDlgItem(hMain,ID_RESET),zDefaultFont());
          ZI_SetAnchorMode(GetDlgItem(hMain,ID_RESET),ANCHOR_RIGHT);
          zStaticCenter(_T("\rLeft mouse button:\rchange view angle.\rRight mouse button:\rchange graph location.\r\rMouse wheel zooming."),ClientW-(7+120+8),10+(22+5)*5+5,120,120,hMain,ID_STATIC);
          ZI_SetAnchorMode(GetDlgItem(hMain,ID_STATIC),ANCHOR_RIGHT);
          hList= CreateWindowEx( 0,_T("ListBox"), NULL, WS_CHILD| WS_BORDER| WS_VISIBLE| WS_VSCROLL| LBS_SORT| LBS_NOTIFY| LBS_HASSTRINGS| LBS_DISABLENOSCROLL, ClientW-( 7+ 120+ 8), 10+( 22+ 5)* 10+ 5, 120, 120, hMain,(HMENU)( HMENU) ID_LISTBOX, hInst, NULL);
          ZI_SetAnchorMode(hList,ANCHOR_RIGHT);
          zSetCTLFont(hList,zDefaultFont());
          gl_LoadTexture(hList);
          dwStyle= WS_CHILD| WS_VISIBLE;
          dwExStyle= 0;
          gn_GLwnd= WGL_CreateWindow( dwExStyle, dwStyle, 0, 0, 844, ClientH, hMain,( HMENU) ID_CTRL);
          if(gn_GLwnd )
            {
              ZI_SetAnchorMode(gn_GLwnd,ANCHOR_HEIGHT_WIDTH);
              GL_UseMouseManager(gn_GLwnd);
              g_mt.resize(4);
              wstring  ws=EXEpath();
              ws+=ListGetText(hList,(long)ListGetCursel(hList));
              wcscpy_s(g_mt[0].FullName,(WCHAR*)ws.c_str());
              g_mt[0].ID= 1;
              g_mt[0].Square= 0;
              ws= EXEpath();
              ws+=_T("chrome.jpg");
              wcscpy_s(g_mt[1].FullName,(WCHAR*)ws.c_str());
              g_mt[1].ID= 2;
              g_mt[1].Square= 0;
              ws= EXEpath();
              ws+=_T("boing.png");
              wcscpy_s(g_mt[2].FullName,(WCHAR*)ws.c_str());
              g_mt[2].ID= 3;
              g_mt[2].Square= 0;
              ws= EXEpath();
              ws+=_T("bubble.png");
              wcscpy_s(g_mt[3].FullName,(WCHAR*)ws.c_str());
              g_mt[3].ID= 4;
              g_mt[3].Square= 0;
              ZI_MakeMultipleTexture( &g_mt[0],(long) _UBOUND(g_mt));
              gn_TexSpecular= g_mt[0].Texture;
              gn_TexChrome= g_mt[1].Texture;
              gn_TexBoing= g_mt[2].Texture;
              gn_TexBubble= g_mt[3].Texture;
              gl_Initialize();
              ZI_BuildGLfont(ZI_GetGLDC(gn_GLwnd),UseFont);
              GlobalFont(UseFont,1);
              gn_ChartCaption= GL_CreateFontTexture( gn_GLwnd,_T("TREBUCHET MS"), 32, 0xFFFFFFFF);
              gn_ChartSymbol= GL_CreateFontTexture( gn_GLwnd,_T("WINGDINGS"), 32, 0xFFFFFFFF);
              gn_ChartLegend= GL_CreateFontTexture( gn_GLwnd,_T("TREBUCHET MS"), 16, 0xFFFFFFFF);
              ShowWindow(hMain,CmdShow);
              SetForegroundWindow(hMain);
              SetFocus(hMain);
              SetTimer(hMain,1,0,0);
              while(GetMessage( &msg,NULL,0,0))
                {
                  TranslateMessage( &msg);
                  DispatchMessage( &msg);
                }

              nRet=( long) msg.wParam;
              KillTimer(hMain,1);
              gl_DestroyTexture();
              ZI_DeleteGLFont(UseFont);
            }
        }
    }
  if(hMutex )
    {
      CloseHandle(hMutex);
    }
  return nRet;
}



